

function JS_Call_APP(methodName, param, callback) {
    if(methodName == 'addListener'){
        JS_Add_Listener(methodName, param, callback);
        return;
    }

    var paramsDic = {};
    paramsDic['methodName'] = methodName;

    if (param == '' || param == null || param == undefined) {
       paramsDic['data'] = '';
    } else { paramsDic['data'] = param }

    if (!window.CYKJCallbacks) {  window.CYKJCallbacks = []; }

    if (callback) { window.CYKJCallbacks[methodName+'_callback'] = callback;
       paramsDic['callback_methodName'] = methodName+'_callback';
    } else { delete window.CYKJCallbacks[methodName+'_callback']; }

     window.ciyun.jsCallAPP(JSON.stringify(paramsDic));
}

function APP_Callback_JS(functionName, status, msg) {
    if (window.CYKJCallbacks) {
        var fun = function(a,b){};
        fun = window.CYKJCallbacks[functionName];
        fun(status, msg);
        delete window.CYKJCallbacks[functionName];
    } else {
    }
}

var app_debug_uniqueId = 1;
function log(message, data) {
   var log = document.getElementById('log');
   if(!log) return;
   var el = document.createElement('div');
   el.innerHTML = app_debug_uniqueId++ + '. ' + message;
   if (data) { el.innerHTML += ':<br/>' + JSON.stringify(data) }
   if (log.children.length) { log.insertBefore(el, log.children[0]) }
   else { log.appendChild(el) }
}

function JS_Add_Listener(methodName, identifie, callback) {
    if(identifie == '' || identifie == null)
    {
        return;
    }

    if(typeof callback != 'function')
    {
        return;
    }

    if(!window.CYKJListener) {
        window.CYKJListener = {};
    }

    var timestamp = new Date().getTime();
    window.CYKJListener[identifie + '_' + timestamp] =  callback;

    var paramsDic = {};
    paramsDic['methodName'] = methodName;
    paramsDic['data'] = identifie;
    window.ciyun.jsCallAPP(JSON.stringify(paramsDic));
}

function JS_Remove_Listener(identifie) {
    var keys = window.CYKJListener.keys;
    for(var i=0,len=keys.length; i<len; i++) {
        if(keys[i].indexOf(identifie) == 0){
            delete window.CYKJListener[keys[i]];
        }
    }
}

function APP_Notify_JS_Listener(identifie, status, msg) {
    if (window.CYKJListener) {
        var listenFuns = {};
        listenFuns = window.CYKJListener;
        for(var funKey in listenFuns) {
            if(funKey.indexOf(identifie) == 0){
                var fun = function(a,b){};
                fun = window.CYKJListener[funKey];
                fun(status, msg);
            }
        }
    } else {
    }
}
